# This file was auto-generated by lib/slack/web/api/tasks/generate.rake

module Slack
  module Web
    module Api
      module Endpoints
        module Users
          #
          # This method lets you find out information about a user's presence.
          # Consult the presence documentation for more details.
          #
          # @option options [user] :user
          #   User to get presence info on. Defaults to the authed user.
          # @see https://api.slack.com/methods/users.getPresence
          # @see https://github.com/dblock/slack-api-ref/blob/master/methods/users.getPresence.json
          def users_getPresence(options = {})
            throw ArgumentError.new('Required arguments :user missing') if options[:user].nil?
            options = options.merge(user: users_id(options)['user']['id']) if options[:user]
            post('users.getPresence', options)
          end

          #
          # This method returns information about a team member.
          #
          # @option options [user] :user
          #   User to get info on.
          # @see https://api.slack.com/methods/users.info
          # @see https://github.com/dblock/slack-api-ref/blob/master/methods/users.info.json
          def users_info(options = {})
            throw ArgumentError.new('Required arguments :user missing') if options[:user].nil?
            options = options.merge(user: users_id(options)['user']['id']) if options[:user]
            post('users.info', options)
          end

          #
          # This method returns a list of all users in the team. This includes deleted/deactivated users.
          #
          # @option options [Object] :presence
          #   Whether to include presence data in the output.
          # @see https://api.slack.com/methods/users.list
          # @see https://github.com/dblock/slack-api-ref/blob/master/methods/users.list.json
          def users_list(options = {})
            post('users.list', options)
          end

          #
          # This method lets the slack messaging server know that the authenticated user
          # is currently active. Consult the presence documentation for
          # more details.
          #
          # @see https://api.slack.com/methods/users.setActive
          # @see https://github.com/dblock/slack-api-ref/blob/master/methods/users.setActive.json
          def users_setActive(options = {})
            post('users.setActive', options)
          end

          #
          # This method lets you set the calling user's manual presence.
          # Consult the presence documentation for more details.
          #
          # @option options [Object] :presence
          #   Either auto or away.
          # @see https://api.slack.com/methods/users.setPresence
          # @see https://github.com/dblock/slack-api-ref/blob/master/methods/users.setPresence.json
          def users_setPresence(options = {})
            throw ArgumentError.new('Required arguments :presence missing') if options[:presence].nil?
            post('users.setPresence', options)
          end
        end
      end
    end
  end
end
